package de.dhbwstuttgart.syntaxtree;

import de.dhbwstuttgart.syntaxtree.type.RefTypeOrTPHOrWildcardOrGeneric;
import org.antlr.v4.runtime.Token;

public abstract class Pattern extends SyntaxTreeNode {
    private final RefTypeOrTPHOrWildcardOrGeneric type;

    public Pattern(RefTypeOrTPHOrWildcardOrGeneric type, Token offset) {
        super(offset);
        this.type = type;
    }

    public RefTypeOrTPHOrWildcardOrGeneric getType(){
        return type;
    }

    public abstract Pattern withType(RefTypeOrTPHOrWildcardOrGeneric type);
}
